﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;

namespace CSharpAddin
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("7A1014B2-E25F-4079-AD2D-B96234E0E2E0"), ProgId("CSharpAddin.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXRibbonTab adxRibbonTabShared;
        private ADXRibbonGroup adxRibbonGroupPrivate;
        private ADXRibbonButton adxRibbonButton;
        private ImageList imageList;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.adxRibbonTabShared = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroupPrivate = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.imageList = new System.Windows.Forms.ImageList(this.components);
            // 
            // adxRibbonTabShared
            // 
            this.adxRibbonTabShared.Caption = "Our shared tab";
            this.adxRibbonTabShared.Controls.Add(this.adxRibbonGroupPrivate);
            this.adxRibbonTabShared.Id = "adxRibbonTab_73ba97036a984c86a8b1dce96f64c1b7";
            this.adxRibbonTabShared.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.adxRibbonTabShared.Shared = true;
            // 
            // adxRibbonGroupPrivate
            // 
            this.adxRibbonGroupPrivate.Caption = "Add-in #1";
            this.adxRibbonGroupPrivate.Controls.Add(this.adxRibbonButton);
            this.adxRibbonGroupPrivate.Id = "adxRibbonGroup_9c42e782b69247729d7d2221a38d881e";
            this.adxRibbonGroupPrivate.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroupPrivate.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // adxRibbonButton
            // 
            this.adxRibbonButton.Caption = "Hello world!";
            this.adxRibbonButton.Id = "adxRibbonButton_8c40fd5776264cc9b9ceffb2b63d1f91";
            this.adxRibbonButton.Image = 0;
            this.adxRibbonButton.ImageList = this.imageList;
            this.adxRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.adxRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.adxRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxRibbonButton_OnClick);
            // 
            // imageList
            // 
            this.imageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList.ImageStream")));
            this.imageList.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList.Images.SetKeyName(0, "SampleIcon1.ico");
            // 
            // AddinModule
            // 
            this.AddinName = "CSharpAddin";
            this.Namespace = "ADXNamespace";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;

        }
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance 
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }

        private void adxRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            System.Windows.Forms.MessageBox.Show(this.ToString(),
                                "Add-in Express sample add-ins", 
               MessageBoxButtons.OK ,MessageBoxIcon.Information );
        }

        public override string ToString()
        {
            return "The first COM add-in with a shared ribbon tab.";
        }

    }
}

